{ dir
, pkgs ? import <channels-nixos-stable> {}
, ownLib ? import ../lib/default.nix { }
, gitRoot ? "$(git rev-parse --show-toplevel)"

# FIXME: why do these need explicit mentioning?
, moreargs ? null
, rebuildarg ? ""
, ...
} @ args :

let
  rebuildargsSudo = [ "switch" "boot" ];
  rebuild = {
    rebuildarg
    , gitRoot
    , moreargs ? null

    , ...
  }: pkgs.writeScript "script" ''
    #!/usr/bin/env bash
    set -xe

    pushd ${gitRoot}/${dir}
    export NIXOS_CONFIG="$PWD"/configuration.nix

    [[ -e "''${NIXOS_CONFIG}" ]]

    ${if (builtins.elem rebuildarg rebuildargsSudo)
          && builtins.match ".*--target-host.*" moreargs == null
    then
      "sudo -E \\"
    else
      ""
    }
    nixos-rebuild --show-trace -I nixos-config=''${NIXOS_CONFIG} ${rebuildarg} ${moreargs}
    if test -L result; then
      rm result
    fi
  '';


in {
  recipes = {
    rebuild = rebuild { inherit gitRoot; inherit (args) rebuildarg moreargs; };
  } // (import ./disk.nix (args // { inherit pkgs ownLib gitRoot; }))
  ;
}
